from __future__ import division
from math import *
import jmp_score as jmp


""" ==================================================================
 Copyright(C) 2018 SAS Institute Inc.All rights reserved.
 
 Notice:
 The following permissions are granted provided that the
 above copyright and this notice appear in the score code and
 any related documentation. Permission to copy, modify
 and distribute the score code generated using
 JMP(R) software is limited to customers of SAS Institute Inc. ("SAS")
 and successive third parties, all without any warranty, express or
 implied, or any other obligation by SAS. SAS and all other SAS
 Institute Inc. product and service names are registered
 trademarks or trademarks of SAS Institute Inc. in the USA
 and other countries. Except as contained in this notice,
 the name of the SAS Institute Inc. and JMP shall not be used in
 the advertising or promotion of products or services without
 prior written authorization from SAS Institute Inc.
 ================================================================== """

""" Python code generated by JMP v14.0.0 """

def getModelMetadata():
	return {"creator": u"Neural", "modelName": u"", "predicted": u"PRICE", "table": u"Redfin St Louis for Modeling", "version": u"14.0.0", "timestamp": u"2017-10-15T21:59:01Z"}


def getInputMetadata():
    return {
        u"YEAR BUILT": "float",
        u"SQUARE FEET": "float",
        u"LOT SIZE": "float",
        u"BATHS": "float",
        u"STATE": "str",
        u"HOA/MONTH": "float",
        u"LATITUDE": "float",
        u"LONGITUDE": "float",
        u"BEDS": "float",
        u"DAYS ON MARKET": "float"
	}


def getOutputMetadata():
    return {
        u"Predicted PRICE": "float"
	}


def score(indata, outdata):
    # Original name was: 'YEAR BUILT Binned'
    # YEAR_BUILT_Binned
    # Original name was: 'SQUARE FEET Or Mean'
    # SQUARE_FEET_Or_Mean
    # Original name was: 'LOT SIZE Or Mean'
    # LOT_SIZE_Or_Mean
    # Original name was: 'BATHS Or Mean'
    # BATHS_Or_Mean
    # Original name was: 'STATE 2'
    # STATE_2
    # Original name was: 'SQUARE FEET IsMissing'
    # SQUARE_FEET_IsMissing
    # Original name was: 'LOT SIZE IsMissing'
    # LOT_SIZE_IsMissing
    # Original name was: 'HOA/MONTH 2'
    # HOA_MONTH_2
    # Cluster
    # Original name was: 'BATHS IsMissing'
    # BATHS_IsMissing
    # Original name was: 'STATE 2_asCode'
    # STATE_2_asCode
    # H2_1
    # H2_2
    # H2_3
    # H1_1
    # H1_2
    # H1_3
    _temp_0 = None
    _temp_1 = None
    _temp_2 = None
    _temp_3 = u""
    _temp_4 = None
    _temp_5 = None
    _temp_6 = None
    # _temp_7
    _temp_8 = [0 for i in range(8)]
    _temp_9 = None
    _temp_10 = None
    _temp_11 = None
    _temp_12 = 1.69840532807802
    _temp_13 = None
    _temp_14 = None
    _temp_15 = None
    _temp_16 = -39.4629603371947
    _temp_17 = None
    _temp_18 = None
    _temp_19 = None
    _temp_20 = -2.15253208606799
    _temp_21 = None
    _temp_22 = None
    _temp_23 = None

    YEAR_BUILT_Binned = 1820 + 50 * floor((-36.4 + 0.02 * indata[u"YEAR BUILT"]))

    if (jmp.is_missing(indata[u"SQUARE FEET"])):
        _temp_0 = 1944.25105759844
    else:
        _temp_0 = indata[u"SQUARE FEET"]
    SQUARE_FEET_Or_Mean = _temp_0

    if (jmp.is_missing(indata[u"LOT SIZE"])):
        _temp_1 = 19633.0188250568
    else:
        _temp_1 = indata[u"LOT SIZE"]
    LOT_SIZE_Or_Mean = _temp_1

    if (jmp.is_missing(indata[u"BATHS"])):
        _temp_2 = 2.55262199563001
    else:
        _temp_2 = indata[u"BATHS"]
    BATHS_Or_Mean = _temp_2

    if (indata[u"STATE"] == u"il"):
        _temp_3 = u"IL"
    else:
        _temp_3 = indata[u"STATE"]
    STATE_2 = _temp_3

    if (jmp.is_missing(indata[u"SQUARE FEET"])):
        _temp_4 = 1
    else:
        _temp_4 = 0
    SQUARE_FEET_IsMissing = _temp_4

    if (jmp.is_missing(indata[u"LOT SIZE"])):
        _temp_5 = 1
    else:
        _temp_5 = 0
    LOT_SIZE_IsMissing = _temp_5

    if (jmp.is_missing(indata[u"HOA/MONTH"])):
        _temp_6 = 0
    else:
        _temp_6 = indata[u"HOA/MONTH"]
    HOA_MONTH_2 = _temp_6

    _temp_8[0] = jmp.pow((-291.696976691981 + 7.58910369377387 * indata[u"LATITUDE"]), 2) + jmp.pow((368.754145266588 + 4.07868938375247 * indata[u"LONGITUDE"]), 2)
    _temp_8[1] = jmp.pow((-292.562682904274 + 7.58910369377387 * indata[u"LATITUDE"]), 2) + jmp.pow((366.970572735524 + 4.07868938375247 * indata[u"LONGITUDE"]), 2)
    _temp_8[2] = jmp.pow((-292.900567163439 + 7.58910369377387 * indata[u"LATITUDE"]), 2) + jmp.pow((369.519631001087 + 4.07868938375247 * indata[u"LONGITUDE"]), 2)
    _temp_8[3] = jmp.pow((-294.075223565458 + 7.58910369377387 * indata[u"LATITUDE"]), 2) + jmp.pow((368.418559035387 + 4.07868938375247 * indata[u"LONGITUDE"]), 2)
    _temp_8[4] = jmp.pow((-295.249071869331 + 7.58910369377387 * indata[u"LATITUDE"]), 2) + jmp.pow((367.611912188939 + 4.07868938375247 * indata[u"LONGITUDE"]), 2)
    _temp_8[5] = jmp.pow((-292.924890322179 + 7.58910369377387 * indata[u"LATITUDE"]), 2) + jmp.pow((368.328014448782 + 4.07868938375247 * indata[u"LONGITUDE"]), 2)
    _temp_8[6] = jmp.pow((-293.93998228727 + 7.58910369377387 * indata[u"LATITUDE"]), 2) + jmp.pow((367.120592440498 + 4.07868938375247 * indata[u"LONGITUDE"]), 2)
    _temp_8[7] = jmp.pow((-294.247274385516 + 7.58910369377387 * indata[u"LATITUDE"]), 2) + jmp.pow((369.979120315575 + 4.07868938375247 * indata[u"LONGITUDE"]), 2)
    _temp_7 = jmp.min_array(8, _temp_8)
    if (_temp_7 == 0):
        _temp_9 = 1
    elif (_temp_7 == 1):
        _temp_9 = 2
    elif (_temp_7 == 2):
        _temp_9 = 3
    elif (_temp_7 == 3):
        _temp_9 = 4
    elif (_temp_7 == 4):
        _temp_9 = 5
    elif (_temp_7 == 5):
        _temp_9 = 6
    elif (_temp_7 == 6):
        _temp_9 = 7
    elif (_temp_7 == 7):
        _temp_9 = 8
    Cluster = _temp_9

    if (jmp.is_missing(indata[u"BATHS"])):
        _temp_10 = 1
    else:
        _temp_10 = 0
    BATHS_IsMissing = _temp_10

    if (STATE_2 == u"MO"):
        _temp_11 = 0
    elif (STATE_2 == u"IL"):
        _temp_11 = 1
    STATE_2_asCode = _temp_11

    if (jmp.numeq(Cluster, 1)):
        _temp_13 = 0.255598964417981
    elif (jmp.numeq(Cluster, 2)):
        _temp_13 = 0.117251974941306
    elif (jmp.numeq(Cluster, 3)):
        _temp_13 = -0.173685602087416
    elif (jmp.numeq(Cluster, 4)):
        _temp_13 = -0.106587230213252
    elif (jmp.numeq(Cluster, 5)):
        _temp_13 = -0.0368338451814097
    elif (jmp.numeq(Cluster, 6)):
        _temp_13 = -0.00340998849655414
    elif (jmp.numeq(Cluster, 7)):
        _temp_13 = -0.277062571336102
    elif (jmp.numeq(Cluster, 8)):
        _temp_13 = 0.224728297955447
    if (jmp.numeq(STATE_2_asCode, 0)):
        _temp_14 = 0.118425840293864
    elif (jmp.numeq(STATE_2_asCode, 1)):
        _temp_14 = -0.118425840293864
    if (jmp.numeq(YEAR_BUILT_Binned, 1820)):
        _temp_15 = -0.0612162618520968
    elif (jmp.numeq(YEAR_BUILT_Binned, 1870)):
        _temp_15 = -0.0702661412896758
    elif (jmp.numeq(YEAR_BUILT_Binned, 1920)):
        _temp_15 = -0.068044978201877
    elif (jmp.numeq(YEAR_BUILT_Binned, 1970)):
        _temp_15 = 0.19952738134365
    _temp_12 += -0.18085802159567 * BATHS_IsMissing
    _temp_12 += -0.0177947879673208 * BATHS_Or_Mean
    _temp_12 += 0.0107848349116184 * indata[u"BEDS"]
    _temp_12 += -0.00105358111413652 * indata[u"DAYS ON MARKET"]
    _temp_12 += -0.00133458554612532 * HOA_MONTH_2
    _temp_12 += 0.0369170205191839 * LOT_SIZE_IsMissing
    _temp_12 += 0.0000006277113722343 * LOT_SIZE_Or_Mean
    _temp_12 += -0.620177441997387 * SQUARE_FEET_IsMissing
    _temp_12 += -0.0000137584025937297 * SQUARE_FEET_Or_Mean
    _temp_12 += -0.000790241498416571 * indata[u"YEAR BUILT"]
    _temp_12 += 0.5 * _temp_13
    _temp_12 += 0.5 * _temp_14
    _temp_12 += 0.5 * _temp_15
    H2_1 = tanh(_temp_12)

    if (jmp.numeq(STATE_2_asCode, 0)):
        _temp_17 = 0.659706035764433
    elif (jmp.numeq(STATE_2_asCode, 1)):
        _temp_17 = -0.659706035764433
    if (jmp.numeq(YEAR_BUILT_Binned, 1820)):
        _temp_18 = 0.493985394569205
    elif (jmp.numeq(YEAR_BUILT_Binned, 1870)):
        _temp_18 = -0.196547846255161
    elif (jmp.numeq(YEAR_BUILT_Binned, 1920)):
        _temp_18 = 0.186639243070307
    elif (jmp.numeq(YEAR_BUILT_Binned, 1970)):
        _temp_18 = -0.484076791384351
    if (jmp.numeq(Cluster, 1)):
        _temp_19 = -0.454363157835409
    elif (jmp.numeq(Cluster, 2)):
        _temp_19 = -0.400664249060595
    elif (jmp.numeq(Cluster, 3)):
        _temp_19 = 0.642016098501784
    elif (jmp.numeq(Cluster, 4)):
        _temp_19 = -0.629052674551244
    elif (jmp.numeq(Cluster, 5)):
        _temp_19 = 0.151127944552835
    elif (jmp.numeq(Cluster, 6)):
        _temp_19 = 1.02088163429655
    elif (jmp.numeq(Cluster, 7)):
        _temp_19 = 0.641600588107108
    elif (jmp.numeq(Cluster, 8)):
        _temp_19 = -0.971546184011025
    _temp_16 += -0.841722672957152 * BATHS_IsMissing
    _temp_16 += 0.665276019459302 * BATHS_Or_Mean
    _temp_16 += 0.106227016359836 * indata[u"BEDS"]
    _temp_16 += -0.00079510349698404 * indata[u"DAYS ON MARKET"]
    _temp_16 += 0.0014913416058791 * HOA_MONTH_2
    _temp_16 += -0.367217689925411 * LOT_SIZE_IsMissing
    _temp_16 += 0.0000073190538308514 * LOT_SIZE_Or_Mean
    _temp_16 += -0.154585033660534 * SQUARE_FEET_IsMissing
    _temp_16 += 0.00166795700255585 * SQUARE_FEET_Or_Mean
    _temp_16 += 0.0173843229566315 * indata[u"YEAR BUILT"]
    _temp_16 += _temp_17
    _temp_16 += _temp_18
    _temp_16 += _temp_19
    H2_2 = _temp_16

    if (jmp.numeq(STATE_2_asCode, 0)):
        _temp_21 = -0.289135456392153
    elif (jmp.numeq(STATE_2_asCode, 1)):
        _temp_21 = 0.289135456392153
    if (jmp.numeq(YEAR_BUILT_Binned, 1820)):
        _temp_22 = 0.0274313827027277
    elif (jmp.numeq(YEAR_BUILT_Binned, 1870)):
        _temp_22 = 0.113208424482094
    elif (jmp.numeq(YEAR_BUILT_Binned, 1920)):
        _temp_22 = -0.325426144391035
    elif (jmp.numeq(YEAR_BUILT_Binned, 1970)):
        _temp_22 = 0.184786337206214
    if (jmp.numeq(Cluster, 1)):
        _temp_23 = 0.193920609536047
    elif (jmp.numeq(Cluster, 2)):
        _temp_23 = 0.156820426724406
    elif (jmp.numeq(Cluster, 3)):
        _temp_23 = 0.182107340958319
    elif (jmp.numeq(Cluster, 4)):
        _temp_23 = -0.163615777722916
    elif (jmp.numeq(Cluster, 5)):
        _temp_23 = -0.121567006150692
    elif (jmp.numeq(Cluster, 6)):
        _temp_23 = -1.01759952232478
    elif (jmp.numeq(Cluster, 7)):
        _temp_23 = -0.233979978819113
    elif (jmp.numeq(Cluster, 8)):
        _temp_23 = 1.00391390779873
    _temp_20 += 0.650474613833213 * BATHS_IsMissing
    _temp_20 += -0.0345349099315053 * BATHS_Or_Mean
    _temp_20 += 0.0332934430354489 * indata[u"BEDS"]
    _temp_20 += 0.00100685908138715 * indata[u"DAYS ON MARKET"]
    _temp_20 += 0.000109684600040914 * HOA_MONTH_2
    _temp_20 += 0.10412788135988 * LOT_SIZE_IsMissing
    _temp_20 += 0.0000018503512159927 * LOT_SIZE_Or_Mean
    _temp_20 += 0.399565512596905 * SQUARE_FEET_IsMissing
    _temp_20 += -0.000717646295901379 * SQUARE_FEET_Or_Mean
    _temp_20 += 0.00213620253451416 * indata[u"YEAR BUILT"]
    _temp_20 += _temp_21
    _temp_20 += _temp_22
    _temp_20 += _temp_23
    H2_3 = jmp.exp(-((0.5 * jmp.pow(_temp_20, 2))))

    H1_1 = tanh((0.0649206123019955 + -0.0574241204702832 * H2_1 + 0.148402293295899 * H2_2 + -0.720797702767809 * H2_3))

    H1_2 = -0.0857155295486457 + -0.0261087544649816 * H2_1 + -2.22099807057823 * H2_2 + 1.33295723981762 * H2_3

    H1_3 = jmp.exp(-((0.5 * jmp.pow((0.044212172809975 + 0.524557406548739 * H2_1 + -0.364495747411131 * H2_2 + 0.0752533271120971 * H2_3), 2))))

    outdata[u"Predicted PRICE"] = 383664.700082214 + 189345.766294827 * H1_1 + -19228.5301112994 * H1_2 + -98016.9877605562 * H1_3

    return outdata[u"Predicted PRICE"]


